Index: branches/HeuristicLab.Modeling Database Backend/sources/HeuristicLab.sln
===================================================================
--- branches/HeuristicLab.Modeling Database Backend/sources/HeuristicLab.sln	(revision 2175)
+++ branches/HeuristicLab.Modeling Database Backend/sources/HeuristicLab.sln	(revision 2181)
@@ -237,4 +237,6 @@
 EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Modeling.SQLiteBackend-3.2", "HeuristicLab.Modeling.SQLiteBackend\3.2\HeuristicLab.Modeling.SQLiteBackend-3.2.csproj", "{2F4ADF67-B9DA-4E0D-A217-DF1CA8AD58CC}"
+EndProject
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Modeling.SQLServerCompactBackend-3.2", "HeuristicLab.Modeling.SQLServerCompactBackend\3.2\HeuristicLab.Modeling.SQLServerCompactBackend-3.2.csproj", "{9B4F7D05-CCE1-45BB-81D1-5D4925851901}"
 EndProject
 Global
@@ -3795,4 +3797,40 @@
 		{2F4ADF67-B9DA-4E0D-A217-DF1CA8AD58CC}.Visualization Debug|x64.ActiveCfg = Debug|Any CPU
 		{2F4ADF67-B9DA-4E0D-A217-DF1CA8AD58CC}.Visualization Debug|x86.ActiveCfg = Debug|Any CPU
+		{9B4F7D05-CCE1-45BB-81D1-5D4925851901}.CEDMA Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{9B4F7D05-CCE1-45BB-81D1-5D4925851901}.CEDMA Debug|Any CPU.Build.0 = Debug|Any CPU
+		{9B4F7D05-CCE1-45BB-81D1-5D4925851901}.CEDMA Debug|x64.ActiveCfg = Debug|x64
+		{9B4F7D05-CCE1-45BB-81D1-5D4925851901}.CEDMA Debug|x64.Build.0 = Debug|x64
+		{9B4F7D05-CCE1-45BB-81D1-5D4925851901}.CEDMA Debug|x86.ActiveCfg = Debug|x86
+		{9B4F7D05-CCE1-45BB-81D1-5D4925851901}.CEDMA Debug|x86.Build.0 = Debug|x86
+		{9B4F7D05-CCE1-45BB-81D1-5D4925851901}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{9B4F7D05-CCE1-45BB-81D1-5D4925851901}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{9B4F7D05-CCE1-45BB-81D1-5D4925851901}.Debug|x64.ActiveCfg = Debug|x64
+		{9B4F7D05-CCE1-45BB-81D1-5D4925851901}.Debug|x64.Build.0 = Debug|x64
+		{9B4F7D05-CCE1-45BB-81D1-5D4925851901}.Debug|x86.ActiveCfg = Debug|x86
+		{9B4F7D05-CCE1-45BB-81D1-5D4925851901}.Debug|x86.Build.0 = Debug|x86
+		{9B4F7D05-CCE1-45BB-81D1-5D4925851901}.Modeling Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{9B4F7D05-CCE1-45BB-81D1-5D4925851901}.Modeling Debug|Any CPU.Build.0 = Debug|Any CPU
+		{9B4F7D05-CCE1-45BB-81D1-5D4925851901}.Modeling Debug|x64.ActiveCfg = Debug|x64
+		{9B4F7D05-CCE1-45BB-81D1-5D4925851901}.Modeling Debug|x64.Build.0 = Debug|x64
+		{9B4F7D05-CCE1-45BB-81D1-5D4925851901}.Modeling Debug|x86.ActiveCfg = Debug|x86
+		{9B4F7D05-CCE1-45BB-81D1-5D4925851901}.Modeling Debug|x86.Build.0 = Debug|x86
+		{9B4F7D05-CCE1-45BB-81D1-5D4925851901}.Release|Any CPU.ActiveCfg = Release|Any CPU
+		{9B4F7D05-CCE1-45BB-81D1-5D4925851901}.Release|Any CPU.Build.0 = Release|Any CPU
+		{9B4F7D05-CCE1-45BB-81D1-5D4925851901}.Release|x64.ActiveCfg = Release|x64
+		{9B4F7D05-CCE1-45BB-81D1-5D4925851901}.Release|x64.Build.0 = Release|x64
+		{9B4F7D05-CCE1-45BB-81D1-5D4925851901}.Release|x86.ActiveCfg = Release|x86
+		{9B4F7D05-CCE1-45BB-81D1-5D4925851901}.Release|x86.Build.0 = Release|x86
+		{9B4F7D05-CCE1-45BB-81D1-5D4925851901}.v3.2 Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{9B4F7D05-CCE1-45BB-81D1-5D4925851901}.v3.2 Debug|Any CPU.Build.0 = Debug|Any CPU
+		{9B4F7D05-CCE1-45BB-81D1-5D4925851901}.v3.2 Debug|x64.ActiveCfg = Debug|x64
+		{9B4F7D05-CCE1-45BB-81D1-5D4925851901}.v3.2 Debug|x64.Build.0 = Debug|x64
+		{9B4F7D05-CCE1-45BB-81D1-5D4925851901}.v3.2 Debug|x86.ActiveCfg = Debug|x86
+		{9B4F7D05-CCE1-45BB-81D1-5D4925851901}.v3.2 Debug|x86.Build.0 = Debug|x86
+		{9B4F7D05-CCE1-45BB-81D1-5D4925851901}.Visualization Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{9B4F7D05-CCE1-45BB-81D1-5D4925851901}.Visualization Debug|Any CPU.Build.0 = Debug|Any CPU
+		{9B4F7D05-CCE1-45BB-81D1-5D4925851901}.Visualization Debug|x64.ActiveCfg = Debug|x64
+		{9B4F7D05-CCE1-45BB-81D1-5D4925851901}.Visualization Debug|x64.Build.0 = Debug|x64
+		{9B4F7D05-CCE1-45BB-81D1-5D4925851901}.Visualization Debug|x86.ActiveCfg = Debug|x86
+		{9B4F7D05-CCE1-45BB-81D1-5D4925851901}.Visualization Debug|x86.Build.0 = Debug|x86
 	EndGlobalSection
 	GlobalSection(SolutionProperties) = preSolution
@@ -3882,4 +3920,5 @@
 		{B9A64475-D542-47CF-9688-735F6224F055} = {410732DB-725A-4824-896B-C298978343C0}
 		{2F4ADF67-B9DA-4E0D-A217-DF1CA8AD58CC} = {410732DB-725A-4824-896B-C298978343C0}
+		{9B4F7D05-CCE1-45BB-81D1-5D4925851901} = {410732DB-725A-4824-896B-C298978343C0}
 		{A9E282EA-180F-4233-B809-AEDF0787545C} = {78982D7C-D63D-4A3D-AE1F-F58AC007603B}
 		{BF7D9494-A586-457B-8DF9-ED599F9E6A71} = {78982D7C-D63D-4A3D-AE1F-F58AC007603B}