Index: branches/HeuristicLab.Modeling Database Backend/sources/HeuristicLab.Modeling.SQLServerCompactBackend/3.2/Algorithm.cs
===================================================================
--- branches/HeuristicLab.Modeling Database Backend/sources/HeuristicLab.Modeling.SQLServerCompactBackend/3.2/Algorithm.cs	(revision 2185)
+++ 	(revision )
@@ -1,56 +1,0 @@
-﻿using System;
-using System.Collections.Generic;
-using System.Linq;
-using System.Data.Linq;
-using System.Data.Linq.Mapping;
-using System.Text;
-
-namespace HeuristicLab.Modeling.SQLServerCompactBackend {
-  [Table(Name = "Algorithm")]
-  public class Algorithm {
-    public Algorithm() {
-    }
-
-    public Algorithm(string name)
-      : this() {
-      this.name = name;
-    }
-
-    public Algorithm(string name, string description)
-      : this(name) {
-      this.description = description;
-    }
-
-    private int id;
-    [Column(Storage = "id", IsPrimaryKey = true, IsDbGenerated = true)]
-    public int Id {
-      get { return this.id; }
-      private set { this.id = value; }
-    }
-
-    private string name;
-    [Column(Storage = "name", CanBeNull = false)]
-    public string Name {
-      get { return this.name; }
-      set { this.name = value; }
-    }
-
-    private string description;
-    [Column(Storage = "description", CanBeNull = true)]
-    public string Description {
-      get { return this.description; }
-      set { this.description = value; }
-    }
-
-    public IEnumerable<Model> ModelsCreatedByThisAlgorithm {
-      get {
-        using (ModelingDataContext ctx = new ModelingDataContext()) {
-          var x = from model in ctx.Models
-                  where model.Algorithm == this
-                  select model;
-          return x.AsEnumerable();
-        }
-      }
-    }
-  }
-}
Index: branches/HeuristicLab.Modeling Database Backend/sources/HeuristicLab.Modeling.SQLServerCompactBackend/3.2/InputVariable.cs
===================================================================
--- branches/HeuristicLab.Modeling Database Backend/sources/HeuristicLab.Modeling.SQLServerCompactBackend/3.2/InputVariable.cs	(revision 2185)
+++ 	(revision )
@@ -1,59 +1,0 @@
-﻿using System;
-using System.Collections.Generic;
-using System.Data.Linq;
-using System.Data.Linq.Mapping;
-using System.Text;
-
-namespace HeuristicLab.Modeling.SQLServerCompactBackend {
-  [Table(Name = "InputVariable")]
-  public class InputVariable {
-    public InputVariable() {
-      this.model = default(EntityRef<Model>);
-      this.variable = default(EntityRef<Variable>);
-    }
-
-    public InputVariable(Model model, Variable variable)
-      : base() {
-      this.model.Entity = model;
-      this.variable.Entity = variable;
-    }
-
-    private int variableId;
-    [Column(Storage = "variableId", IsPrimaryKey = true)]
-    public int VariableId {
-      get { return this.variableId; }
-      private set {
-        if (variableId != value) {
-          if (variable.HasLoadedOrAssignedValue)
-            throw new ForeignKeyReferenceAlreadyHasValueException();
-          variableId = value;
-        }
-      }
-    }
-
-    private EntityRef<Variable> variable;
-    [Association(Storage = "variable", ThisKey = "VariableId", OtherKey = "Id", IsForeignKey = true)]
-    public Variable Variable {
-      get { return variable.Entity; }
-    }
-
-    private int modelId;
-    [Column(Storage = "modelId", IsPrimaryKey = true)]
-    public int ModelId {
-      get { return this.modelId; }
-      private set {
-        if (modelId != value) {
-          if (model.HasLoadedOrAssignedValue)
-            throw new ForeignKeyReferenceAlreadyHasValueException();
-          modelId = value;
-        }
-      }
-    }
-
-    private EntityRef<Model> model;
-    [Association(Storage = "model", ThisKey = "ModelId", OtherKey = "Id", IsForeignKey = true)]
-    public Model Model {
-      get { return model.Entity; }
-    }
-  }
-}
Index: branches/HeuristicLab.Modeling Database Backend/sources/HeuristicLab.Modeling.SQLServerCompactBackend/3.2/InputVariableResult.cs
===================================================================
--- branches/HeuristicLab.Modeling Database Backend/sources/HeuristicLab.Modeling.SQLServerCompactBackend/3.2/InputVariableResult.cs	(revision 2185)
+++ 	(revision )
@@ -1,73 +1,0 @@
-﻿using System;
-using System.Collections.Generic;
-using System.Data.Linq;
-using System.Data.Linq.Mapping;
-using System.Text;
-
-namespace HeuristicLab.Modeling.SQLServerCompactBackend {
-  [Table(Name="InputVariableResult")]
-  public class InputVariableResult {
-    public InputVariableResult() {
-      this.model = default(EntityRef<Model>);
-      this.variable = default(EntityRef<Variable>);
-      this.result = default(EntityRef<Result>);
-    }
-
-    private int variableId;
-    [Column(Storage = "variableId", IsPrimaryKey = true)]
-    public int VariableId {
-      get { return this.variableId; }
-      private set {
-        if (variableId != value) {
-          if (variable.HasLoadedOrAssignedValue)
-            throw new ForeignKeyReferenceAlreadyHasValueException();
-          variableId = value;
-        }
-      }
-    }
-
-    private EntityRef<Variable> variable;
-    [Association(Storage = "variable", ThisKey = "VariableId", OtherKey = "Id", IsForeignKey = true)]
-    public Variable Variable {
-      get { return variable.Entity; }
-    }
-
-    private int modelId;
-    [Column(Storage = "modelId", IsPrimaryKey = true)]
-    public int ModelId {
-      get { return this.modelId; }
-      private set {
-        if (modelId != value) {
-          if (model.HasLoadedOrAssignedValue)
-            throw new ForeignKeyReferenceAlreadyHasValueException();
-          modelId = value;
-        }
-      }
-    }
-
-    private EntityRef<Model> model;
-    [Association(Storage = "model", ThisKey = "ModelId", OtherKey = "Id", IsForeignKey = true)]
-    public Model Model {
-      get { return model.Entity; }
-    }
-
-    private int resultId;
-    [Column(Storage = "resultId", IsPrimaryKey = true)]
-    public int ResultId {
-      get { return this.resultId; }
-      private set {
-        if (resultId != value) {
-          if (result.HasLoadedOrAssignedValue)
-            throw new ForeignKeyReferenceAlreadyHasValueException();
-          resultId = value;
-        }
-      }
-    }
-
-    private EntityRef<Result> result;
-    [Association(Storage = "result", ThisKey = "ResultId", OtherKey = "Id", IsForeignKey = true)]
-    public Result Result {
-      get { return result.Entity; }
-    }
-  }
-}
Index: branches/HeuristicLab.Modeling Database Backend/sources/HeuristicLab.Modeling.SQLServerCompactBackend/3.2/Model.cs
===================================================================
--- branches/HeuristicLab.Modeling Database Backend/sources/HeuristicLab.Modeling.SQLServerCompactBackend/3.2/Model.cs	(revision 2185)
+++ 	(revision )
@@ -1,124 +1,0 @@
-﻿using System;
-using System.Collections.Generic;
-using System.Linq;
-using System.Data.Linq;
-using System.Data.Linq.Mapping;
-using System.Text;
-
-namespace HeuristicLab.Modeling.SQLServerCompactBackend {
-  [Table(Name = "Model")]
-  public class Model {
-    public Model() {
-      targetVariable = default(EntityRef<Variable>);
-      algorithm = default(EntityRef<Algorithm>);
-    }
-
-    public Model(Variable targetVariable, Algorithm algorithm, object data)
-      : this() {
-      this.TargetVariable = targetVariable;
-      this.Algorithm = algorithm;
-      this.data = data;
-    }
-
-    private int id;
-    [Column(Storage = "id", IsPrimaryKey = true, IsDbGenerated = true)]
-    public int Id {
-      get { return this.id; }
-      private set { this.id = value; }
-    }
-
-    private object data;
-    [Column(Storage = "data", DbType = "varbinary(8000)", CanBeNull = false)]
-    public object Data {
-      get { return this.data; }
-      set { this.data = value; }
-    }
-
-    private int algorithmId;
-    [Column(Storage = "algorithmId", CanBeNull = false)]
-    public int AlgorithmId {
-      get { return this.algorithmId; }
-      private set {
-        if (algorithmId != value) {
-          if (algorithm.HasLoadedOrAssignedValue)
-            throw new ForeignKeyReferenceAlreadyHasValueException();
-          algorithmId = value;
-        }
-      }
-    }
-
-    private EntityRef<Algorithm> algorithm;
-    [Association(Storage = "algorithm", ThisKey = "AlgorithmId", OtherKey = "Id", IsForeignKey = true)]
-    public Algorithm Algorithm {
-      get { return this.algorithm.Entity; }
-      set {
-        Algorithm previousValue = algorithm.Entity;
-        if (previousValue != value || (!algorithm.HasLoadedOrAssignedValue)) {
-          if (previousValue != null) {
-            algorithm.Entity = null;
-          }
-          algorithm.Entity = value;
-          if (value != null) {
-            algorithmId = value.Id;
-          }
-        }
-      }
-    }
-
-    private int targetVariableId;
-    [Column(Storage = "targetVariableId", CanBeNull = false)]
-    public int TargetVariableId {
-      get { return this.targetVariableId; }
-      private set {
-        if (targetVariableId != value) {
-          if (targetVariable.HasLoadedOrAssignedValue)
-            throw new ForeignKeyReferenceAlreadyHasValueException();
-          targetVariableId = value;
-        }
-      }
-    }
-
-    private EntityRef<Variable> targetVariable;
-    [Association(Storage = "targetVariable", ThisKey = "TargetVariableId", OtherKey = "Id", IsForeignKey = true)]
-    public Variable TargetVariable {
-      get { return this.targetVariable.Entity; }
-      set {
-        Variable previousValue = targetVariable.Entity;
-        if (previousValue != value || (!targetVariable.HasLoadedOrAssignedValue)) {
-          if (previousValue != null) {
-            targetVariable.Entity = null;
-          }
-          targetVariable.Entity = value;
-          if (value != null) {
-            targetVariableId = value.Id;
-          } 
-        }
-      }
-    }
-
-    public IEnumerable<Variable> InputVariables {
-      get {
-        using (ModelingDataContext ctx = new ModelingDataContext()) {
-          var x = from inputVariable in ctx.InputVariables
-                  where inputVariable.Model == this
-                  select inputVariable.Variable;
-          return x.AsEnumerable();
-        }
-      }
-    }
-
-    public Dictionary<string, double> ResultValues {
-      get {
-        using (ModelingDataContext ctx = new ModelingDataContext()) {
-          var x = (from modelResult in ctx.ModelResults
-                   where modelResult.Model == this
-                   select modelResult)
-                  .ToDictionary(
-                    modelResult => modelResult.Result.Name,
-                    modelResult => modelResult.Value);
-          return x;
-        }
-      }
-    }
-  }
-}
Index: branches/HeuristicLab.Modeling Database Backend/sources/HeuristicLab.Modeling.SQLServerCompactBackend/3.2/ModelResult.cs
===================================================================
--- branches/HeuristicLab.Modeling Database Backend/sources/HeuristicLab.Modeling.SQLServerCompactBackend/3.2/ModelResult.cs	(revision 2185)
+++ 	(revision )
@@ -1,92 +1,0 @@
-﻿using System;
-using System.Collections.Generic;
-using System.Data.Linq;
-using System.Data.Linq.Mapping;
-using System.Text;
-
-namespace HeuristicLab.Modeling.SQLServerCompactBackend {
-  [Table(Name = "ModelResult")]
-  public class ModelResult {
-    public ModelResult() {
-      this.model = default(EntityRef<Model>);
-      this.result = default(EntityRef<Result>);
-    }
-
-    public ModelResult(Model model, Result result, double value)
-      : this() {
-      this.Model = model;
-      this.Result = result;
-      this.value = value;
-    }
-
-    private double value;
-    [Column(Storage = "value", CanBeNull = false)]
-    public double Value {
-      get { return this.value; }
-      set { this.value = value; }
-    }
-
-    private int modelId;
-    [Column(Storage = "modelId", CanBeNull = false)]
-    public int ModelId {
-      get { return this.modelId; }
-      private set {
-        if (modelId != value) {
-          if (model.HasLoadedOrAssignedValue)
-            throw new ForeignKeyReferenceAlreadyHasValueException();
-        }
-        modelId = value;
-      }
-    }
-
-    private EntityRef<Model> model;
-    [Association(Storage = "model", ThisKey = "ModelId", OtherKey = "Id", IsForeignKey = true)]
-    public Model Model {
-      get { return this.model.Entity; }
-      set {
-        Model previousValue = model.Entity;
-        if (previousValue != value || (!model.HasLoadedOrAssignedValue)) {
-          if (previousValue != null) {
-            model.Entity = null;
-          }
-          model.Entity = value;
-          if (value != null) {
-            modelId = value.Id;
-          } 
-        }
-      }
-    }
-
-    private int resultId;
-    [Column(Storage = "resultId", CanBeNull = false)]
-    public int ResultId {
-      get { return this.resultId; }
-      private set {
-        if (resultId != value) {
-          if (result.HasLoadedOrAssignedValue)
-            throw new ForeignKeyReferenceAlreadyHasValueException();
-        }
-        modelId = value;
-      }
-    }
-
-    private EntityRef<Result> result;
-    [Association(Storage = "result", ThisKey = "ResultId", OtherKey = "Id", IsForeignKey = true)]
-    public Result Result {
-      get { return this.result.Entity; }
-      set {
-        Result previousValue = result.Entity;
-        if (previousValue != value || (!model.HasLoadedOrAssignedValue)) {
-          if (previousValue != null) {
-            result.Entity = null;
-          }
-          result.Entity = value;
-          if (value != null) {
-            resultId = value.Id;
-          }
-        }
-      }
-    }
-
-  }
-}
Index: branches/HeuristicLab.Modeling Database Backend/sources/HeuristicLab.Modeling.SQLServerCompactBackend/3.2/Problem.cs
===================================================================
--- branches/HeuristicLab.Modeling Database Backend/sources/HeuristicLab.Modeling.SQLServerCompactBackend/3.2/Problem.cs	(revision 2185)
+++ 	(revision )
@@ -1,34 +1,0 @@
-﻿using System;
-using System.Collections.Generic;
-using System.Data.Linq;
-using System.Data.Linq.Mapping;
-using System.Text;
-
-using HeuristicLab.DataAnalysis;
-
-namespace HeuristicLab.Modeling.SQLServerCompactBackend {
-  [Table(Name = "Problem")]
-  public class Problem {
-    public Problem() {
-    }
-
-    public Problem(Dataset dataset)
-      : this() {
-      this.dataset = dataset;
-    }
-
-    private int id;
-    [Column(Storage = "id", IsPrimaryKey = true, IsDbGenerated = true)]
-    public int Id {
-      get { return this.id; }
-      private set { this.id = value; }
-    }
-
-    private Dataset dataset;
-    [Column(Storage = "dataset", DbType = "varbinary(8000)", CanBeNull = false)]
-    public Dataset Dataset {
-      get { return this.dataset; }
-      private set { this.dataset = value; }
-    }
-  }
-}
Index: branches/HeuristicLab.Modeling Database Backend/sources/HeuristicLab.Modeling.SQLServerCompactBackend/3.2/Result.cs
===================================================================
--- branches/HeuristicLab.Modeling Database Backend/sources/HeuristicLab.Modeling.SQLServerCompactBackend/3.2/Result.cs	(revision 2185)
+++ 	(revision )
@@ -1,47 +1,0 @@
-﻿using System;
-using System.Collections.Generic;
-using System.Linq;
-using System.Data.Linq;
-using System.Data.Linq.Mapping;
-using System.Text;
-
-namespace HeuristicLab.Modeling.SQLServerCompactBackend {
-  [Table(Name = "Result")]
-  public class Result {
-    public Result() {
-    }
-
-    public Result(string name)
-      : this() {
-      this.name = name;
-    }
-
-    private int id;
-    [Column(Storage = "id", IsPrimaryKey = true, IsDbGenerated = true)]
-    public int Id {
-      get { return this.id; }
-      private set { this.id = value; }
-    }
-
-    private string name;
-    [Column(Storage = "name", CanBeNull = false)]
-    public string Name {
-      get { return this.name; }
-      private set { this.name = value; }
-    }
-
-    public Dictionary<Model, double> ModelResultValues {
-      get {
-        using (ModelingDataContext ctx = new ModelingDataContext()) {
-          var x = (from modelResult in ctx.ModelResults
-                   where modelResult.Result == this
-                   select modelResult).ToDictionary(
-                    mr => mr.Model,
-                    mr => mr.Value);
-          return x;
-        }
-      }
-    }
-
-  }
-}
Index: branches/HeuristicLab.Modeling Database Backend/sources/HeuristicLab.Modeling.SQLServerCompactBackend/3.2/Variable.cs
===================================================================
--- branches/HeuristicLab.Modeling Database Backend/sources/HeuristicLab.Modeling.SQLServerCompactBackend/3.2/Variable.cs	(revision 2185)
+++ 	(revision )
@@ -1,55 +1,0 @@
-﻿using System;
-using System.Collections.Generic;
-using System.Linq;
-using System.Data.Linq;
-using System.Data.Linq.Mapping;
-using System.Text;
-
-namespace HeuristicLab.Modeling.SQLServerCompactBackend {
-  [Table(Name = "Variable")]
-  public class Variable {
-    public Variable() {
-    }
-
-    public Variable(string name)
-      : this() {
-      this.name = name;
-    }
-
-    private int id;
-    [Column(Storage = "id", IsPrimaryKey = true, IsDbGenerated = true)]
-    public int Id {
-      get { return this.id; }
-      private set { this.id = value; }
-    }
-
-    private string name;
-    [Column(Storage = "name", CanBeNull = false)]
-    public string Name {
-      get { return this.name; }
-      private set { this.name = value; }
-    }
-
-    public IEnumerable<Model> ModelsPredictingThisVariable {
-      get {
-        using (ModelingDataContext ctx = new ModelingDataContext()) {
-          var x = from model in ctx.Models
-                  where model.TargetVariable == this
-                  select model;
-          return x.AsEnumerable();
-        }
-      }
-    }
-
-    public IEnumerable<Model> ModelsUsingThisVariable {
-      get {
-        using (ModelingDataContext ctx = new ModelingDataContext()) {
-          var x = from inputVariable in ctx.InputVariables
-                  where inputVariable.Variable == this
-                  select inputVariable.Model;
-          return x.AsEnumerable();
-        }
-      }
-    }
-  }
-}